<?php
/*
Plugin Name: Social Sentiment
Plugin URI: 
Description: sentiment mining for social media.
Author: scideas software
Author URI: http://new.scideas.net
Version: 1.0
Text Domain: 
License: GPL version 2 or later - 
*/
/*error_reporting(E_ALL);
ini_set('display_errors', '1');*/
include_once('social_sentiment_common.php');
$goesLeft = $status = '';
$siteurl = get_option('siteurl');
$pluginsUrl = plugins_url();
define('social_sentiment_URL', $pluginsUrl.'/'. basename(dirname(__FILE__)));

global $wpdb, $social_sentimentConfigTable,$social_sentimentSearchTable,$social_sentimentItemsTable,$social_sentiment_shortcode_loaded;
$comp_table_prefix=$wpdb->prefix;
define('social_sentiment_TABLE_PREFIX', $comp_table_prefix);
$social_sentimentConfigTable = social_sentiment_TABLE_PREFIX."social_sentiment_config";
$social_sentimentSearchTable = social_sentiment_TABLE_PREFIX."social_sentiment_search";
$social_sentimentItemsTable = social_sentiment_TABLE_PREFIX."social_sentiment_items";
$social_sentiment_shortcode_loaded = false;

function social_sentiment_plugin_deactivate()
{
	//clear results updater
	wp_clear_scheduled_hook('social_sentiment_update_sentiment_action');
/*    global $wpdb;
    $table = social_sentiment_TABLE_PREFIX."social_sentiment_custom_buttons";
    $structure = "drop table if exists $table";
    $wpdb->query($structure);*/
}

function social_sentiment_plugin_activate() {
  //add_option( 'Activated_Plugin', 'Plugin-Slug' );	
	
	social_sentiment_log("social_sentiment plugin loaded at ".social_sentiment_timestampToDate(time()));
	social_sentiment_install();
	social_sentiment_log("social_sentiment installed");
	social_sentiment_initialize();
	wp_schedule_event(time(), 'daily', 'social_sentiment_update_sentiment_action');
	social_sentiment_log("social_sentiment_update initiated");
	
	add_option( 'Activated_Plugin', 'social_sentiment' );

  /* activation code here */
}
register_activation_hook( __FILE__, 'social_sentiment_plugin_activate' );
register_deactivation_hook(__FILE__ , 'social_sentiment_plugin_deactivate' );

function social_sentiment_load_plugin() {
	//wp_register_style('social_sentiment-googleFonts', '//fonts.googleapis.com/css?family=PT+Serif:400,400italic|Crete+Round:400,400italic|Vidaloka:400,400italic');
    //wp_enqueue_style( 'social_sentiment-googleFonts');
    if ( is_admin() && get_option( 'Activated_Plugin' ) == 'social_sentiment' ) {
		delete_option( 'Activated_Plugin' );
    }
	wp_enqueue_script("json2");
	wp_enqueue_script("jquery");
	wp_enqueue_script("social_sentiment_jsapi",social_sentiment_URL."/social_sentiment_jsapi.js");
	//wp_enqueue_script("social_sentiment_jsapi","//www.google.com/jsapi");
	wp_enqueue_style( 'wp-color-picker' );
    wp_enqueue_script( 'wp-color-picker-script', plugins_url('social_sentiment_plugin.js', __FILE__ ), array( 'wp-color-picker' ), false, true );
}
add_action( 'admin_init', 'social_sentiment_load_plugin' );
add_action('init', 'social_sentiment_load_plugin');
//register_activation_hook(__FILE__,'social_sentiment_install');

function social_sentiment_search_menu() {
    include('social_sentiment_search.php');
}
function social_sentiment_credentials_menu() {
    include('social_sentiment_config.php');
}
function social_sentiment_help_menu() {
    include('social_sentiment_help.php');
}
//
function social_sentiment_admin_actions() {
	//add_menu_page( $page_title, $menu_title, $capability, $menu_slug, $function, $icon_url, $position );
    add_menu_page("social_sentiment", "social_sentiment", 'manage_options','social_sentiment_config' , "social_sentiment_credentials_menu");
	//add_submenu_page( $parent_slug, $page_title, $menu_title, $capability, $menu_slug, $function );
    $configPage = add_submenu_page('social_sentiment_config','social_sentiment Config','social_sentiment Config','manage_options','social_sentiment_config','social_sentiment_credentials_menu');
    $searchPage = add_submenu_page('social_sentiment_config','social_sentiment Search','social_sentiment Search','manage_options','social_sentiment_search','social_sentiment_search_menu');
	$helpPage = add_submenu_page('social_sentiment_config','social_sentiment Help','social_sentiment Help','manage_options','social_sentiment_help','social_sentiment_help_menu');
	
	add_action( 'load-' . $configPage, 'social_sentiment_load_admin_css' );
	add_action( 'load-' . $searchPage, 'social_sentiment_load_admin_css' );
	add_action( 'load-' . $helpPage, 'social_sentiment_load_admin_css' );
	add_action( 'load-' . $configPage, 'social_sentiment_load_admin_script' );
	add_action( 'load-' . $searchPage, 'social_sentiment_load_admin_script' );
}
add_action('admin_menu', 'social_sentiment_admin_actions');
//color picker
function social_sentiment_load_admin_css(){
	wp_enqueue_style('social_sentiment_style', social_sentiment_URL . '/social_sentiment_plugin_admin.css');
}
function social_sentiment_load_admin_script(){
	wp_enqueue_script("social_sentiment_javascript_main",social_sentiment_URL."/social_sentiment_plugin.js");
}
//
function social_sentiment_install()
{
    global $wpdb, $social_sentimentConfigTable,$social_sentimentSearchTable,$social_sentimentItemsTable;
	//if($result = $wpdb->query("SHOW TABLES LIKE '$social_sentimentConfigTable'") < 1){
		//if social_sentiment_config doesn't exist, create it and copy any data from bm basic
		$structure = "CREATE TABLE IF NOT EXISTS $social_sentimentConfigTable (
			 `id` int(9) NOT NULL AUTO_INCREMENT,
			 `domain` varchar(255),
			 `api_key` varchar(255),
			 `status` varchar(20) NOT NULL DEFAULT 'trial',
			 `max_charts` int(3) NOT NULL DEFAULT 1,
			 `goes_left_today` int(6) NOT NULL DEFAULT 0,
			 `item_number` tinyint(4) NOT NULL DEFAULT 30,
			 `max_item_number` tinyint(4) NOT NULL DEFAULT 100,
			 `positive_colour` varchar(8) NOT NULL DEFAULT '#00ed2c',
			 `neutral_colour` varchar(8) NOT NULL DEFAULT '#1a46f3',
			 `negative_colour` varchar(8) NOT NULL DEFAULT '#f53b41',
			 UNIQUE KEY `id` (`id`)
		);";
		$wpdb->query($structure);
		//
		$structure = "CREATE TABLE IF NOT EXISTS $social_sentimentSearchTable (
			 `id` int(9) NOT NULL AUTO_INCREMENT,
			 `term` varchar(255),
			 `type` varchar(255),
			 `number` int(3) NOT NULL DEFAULT 30,
			 UNIQUE KEY `id` (`id`)
		);";
		$wpdb->query($structure);
		//
		$structure = "CREATE TABLE IF NOT EXISTS $social_sentimentItemsTable (
			 `id` int(9) NOT NULL AUTO_INCREMENT,
			 `search_id` int(6) NOT NULL DEFAULT 0,
			 `date` varchar(18),
			 `name` varchar(30),
			 `text` varchar(140),
			 `score_neutral` DECIMAL(5,2),
			 `score_negative` DECIMAL(5,2),
			 `score_positive` DECIMAL(5,2),
			 UNIQUE KEY `id` (`id`)
		);";
		$wpdb->query($structure);
	//}
}
function social_sentiment_initialize(){
	global $wpdb, $social_sentimentConfigTable;
	$host = get_option('siteurl');
	$serviceBase = "http://services.scideas.net/sentiment/initialize_remote.php";
	$params['host'] = $host;
	//$service = $serviceBase."?host=".$host;
    //$result = file_get_contents($service);
	$result = social_sentiment_httpPost($serviceBase,$params);
	$result=json_decode($result,true);
	social_sentiment_log($result['message']);
	$key = $result['key'];
	$goesLeft = $result['goes_left']? $result['goes_left'] : 0;
	$maxCharts = $result['max_charts']? $result['max_charts'] : 1;
	$status = $result['plan_name']? $result['plan_name'] : 'trial';
	$maxNumber = $result['max_items']? $result['max_items'] : 100;
	if($result['status'] == 'success' && $result['message'] == 'initialization complete'){
		if($wpdb->query("INSERT into $social_sentimentConfigTable (`domain`,`api_key`,`status`,`max_charts`,`goes_left_today`,`max_item_number`) VALUES('$host','$key','$status',$maxCharts,$goesLeft,$maxNumber)") === FALSE){
			social_sentiment_log("Initialization failed (".$wpdb->last_error.")");
		}else
		{
			social_sentiment_log("social_sentiment initialized");
		}
	}else
	if($result['status'] == 'success' && strstr($result['message'],'already registered')){
		//check if record exists
		$config = $wpdb->get_results("SELECT * from `$social_sentimentConfigTable`");
		if(count($config) > 0){
			//update existing record
			$query = $wpdb->prepare("UPDATE `$social_sentimentConfigTable` set `status`=%s,`max_charts`=%d,`goes_left_today`=%d,`max_item_number`=%d",$status,$maxCharts,$goesLeft,$maxNumber);
			$res = $wpdb->query($query);
			if(FALSE === $res){
				social_sentiment_log("Goes left update failed (".$wpdb->last_error.")");
			}else
			{
				social_sentiment_log("social_sentiment goes left updated");
			}
		}else
		{
			//create new record
			if($wpdb->query("INSERT into $social_sentimentConfigTable (`domain`,`api_key`,`status`,`max_charts`,`goes_left_today`) VALUES('$host','$key','$status',$maxCharts,$goesLeft)") === FALSE){
				social_sentiment_log("Initialization failed (".$wpdb->last_error.")");
			}else
			{
				social_sentiment_log("social_sentiment initialized");
			}
		}
		
	}else
	{
		social_sentiment_log("Initialization failed (".$result['message'].")");
	}
	//var_dump($result);
	return json_encode($result);
	//exit;
}
//
//initialize over ajax
add_action('wp_ajax_nopriv_social_sentiment_ajax_initialize','social_sentiment_ajax_initialize');
add_action('wp_ajax_social_sentiment_ajax_initialize','social_sentiment_ajax_initialize');
function social_sentiment_ajax_initialize(){
	echo social_sentiment_initialize();
	exit;
}
//get sentiment
add_action('wp_ajax_nopriv_social_sentiment_get_sentiment','social_sentiment_get_sentiment');
add_action('wp_ajax_social_sentiment_get_sentiment','social_sentiment_get_sentiment');
function social_sentiment_get_sentiment(){
	global $wpdb,$social_sentimentConfigTable;
	$goesLeft = $status = $search = $type = '';
	$config = $wpdb->get_results("SELECT * from `$social_sentimentConfigTable`");
	if(count($config) > 0){
		$key = $config[0]->api_key;
		$itemNumber= $config[0]->item_number;
	}
	if($itemNumber == ''){$itemNumber = 20;}
	$search = $_REQUEST['search_term'];
	$type = $_REQUEST['type'];
	$number = intval($_REQUEST['number']) > 0 ? intval($_REQUEST['number']) : $itemNumber;
	$host = get_option('siteurl');
	$serviceBase = "http://services.scideas.net/sentiment/twitter_sentiment.php";
	//$service = $serviceBase."?search=".$search."&type=".$type."&number=".$number."&host=".$host."&key=".$key;
	//$result = file_get_contents($service);
	$params = array('search' => $search, 'type'=>$type, 'number'=>$number, 'host'=>$host, 'key'=>$key);
	$result = social_sentiment_httpPost($serviceBase,$params);
    
	$decoded = json_decode($result,true);
	if($decoded['status'] == 'success'){
		if($decoded['plan_name']){
			$status = $decoded['plan_name'];
		}
		if($decoded['goes_left']){
			$goesLeft = $decoded['goes_left'];
		}
		if($status != '' && $goesLeft != ''){
			if($wpdb->query("UPDATE $social_sentimentConfigTable SET `status`='$status',`goes_left_today`=$goesLeft") === FALSE){
				social_sentiment_log("status update failed (".$wpdb->last_error.")");
			}
		}else
		{
			social_sentiment_log("remote call failed, service status or goes left missing ".$decoded['message']);	
		}
	}else
	{
		social_sentiment_log("remote call failed ".$decoded['message']);	
	}
	//var_dump($result);
	echo $result;
	exit;
}
//
//update sentiment
add_action('social_sentiment_update_sentiment_action', 'social_sentiment_update_sentiment');
function social_sentiment_update_sentiment(){
	global $wpdb,$social_sentimentConfigTable,$social_sentimentSearchTable,$social_sentimentItemsTable;
	$goesLeft = $status = $search = $type = $maxCharts = '';
	social_sentiment_log("Running update");
	$config = $wpdb->get_results("SELECT * from `$social_sentimentConfigTable`");
	if(count($config) > 0){
		$key = $config[0]->api_key;
		$maxCharts = $config[0]->max_charts;
	}else
	{
		social_sentiment_log("Failed to read config table for update");
		return;	
	}
	$searches = $wpdb->get_results("SELECT * from `$social_sentimentSearchTable`");
	if(false === $searches || count($searches) < 1){
		social_sentiment_log("Failed to read search table for update");
		return;
	}
	$host = get_option('siteurl');
	$searchCnt = 1;
	foreach($searches as $search){
		$searchId = $search->id;
		if($searchCnt > $maxCharts){
			$query = $wpdb->prepare("DELETE from $social_sentimentSearchTable WHERE `id`=%d",$searchId);
			$delete = $wpdb->query($query);
			$query = $wpdb->prepare("DELETE from $social_sentimentItemsTable WHERE `search_id`=%d",$searchId);
			$delete = $wpdb->query($query);
			continue;	
		}
		
		$searchTerm = $search->term;
		$type = $search->type;
		$number = $search->number;
		//
		$serviceBase = "http://services.scideas.net/sentiment/twitter_sentiment.php";
		$params = array('search' => $searchTerm, 'search_id' => $searchId, 'type'=>$type, 'number'=>$number, 'host'=>$host, 'key'=>$key);
		$result = social_sentiment_httpPost($serviceBase,$params);
		
		$decoded = json_decode($result,true);
		if($decoded['status'] == 'success'){
			$items = $decoded['items'];
			if(count($items) > 0){
				//remove existing items for this search
				$query = $wpdb->prepare("DELETE from $social_sentimentItemsTable WHERE `search_id`=%d",$searchId);
				$delete = $wpdb->query($query);
				if(false === $delete){
					//skip this search
					continue;	
				}
				//update items table
				foreach($items as $item){
					$date = $item['date'];
					$name = $item['name'];
					$text = $item['text'];
					$scoreNeutral = $item['score_neutral'];
					$scoreNegative = $item['score_negative'];
					$scorePositive = $item['score_positive'];
					$query = $wpdb->prepare("INSERT into `$social_sentimentItemsTable` (`search_id`,`date`,`name`,`text`,`score_neutral`,`score_negative`,`score_positive`) VALUES(%d,%s,%s,%s,%s,%s,%s)",$searchId,$date,$name,$text,$scoreNeutral,$scoreNegative,$scorePositive);
					$update = $wpdb->query($query);
					if(false === $update){
						social_sentiment_log("status update failed (".$wpdb->last_error.")");
					}
				}
			}else
			{
				social_sentiment_log("No items for search ".$type.$searchTerm);
			}
	
		}else
		{
			social_sentiment_log("remote call failed ".$decoded['message']);	
		}
		$searchCnt++;
	}
	social_sentiment_log("Sentiment update complete");
	return;
}
//save sentiment
add_action('wp_ajax_nopriv_social_sentiment_save_sentiment','social_sentiment_save_sentiment');
add_action('wp_ajax_social_sentiment_save_sentiment','social_sentiment_save_sentiment');
function social_sentiment_save_sentiment(){
	global $wpdb,$social_sentimentConfigTable,$social_sentimentSearchTable,$social_sentimentItemsTable;
	$search = $_REQUEST['search_term'];
	$type = $_REQUEST['type'];
	$number = intval($_REQUEST['number']);
	$items = $_REQUEST['items'];
	//add terms to search table
	$query = $wpdb->prepare("INSERT into `$social_sentimentSearchTable` (`term`,`type`,`number`) VALUES(%s,%s,%d)",$search,$type,$number);
		$res = $wpdb->query($query);
		if(false === $res){
			social_sentiment_log("inserting new search failed: ".$wpdb->last_error);
			$result['status'] = "error";
			$result['message'] = "Failed to add search to database";
			echo json_encode($result);
			exit;
		}else
		{
			//add items to items table
			$searchId = $wpdb->insert_id;
			foreach($items as $item){
				$date = $item['date'];
				$name = $item['name'];
				$text = $item['text'];
				$scoreNeutral = $item['score_neutral'];
				$scoreNegative = $item['score_negative'];
				$scorePositive = $item['score_positive'];
				$query = $wpdb->prepare("INSERT into `$social_sentimentItemsTable` (`search_id`,`date`,`name`,`text`,`score_neutral`,`score_negative`,`score_positive`) VALUES(%d,%s,%s,%s,%s,%s,%s)",$searchId,$date,$name,$text,$scoreNeutral,$scoreNegative,$scorePositive);		
				$res2 = $wpdb->query($query);
				if(false === $res2){
					social_sentiment_log("inserting new search failed: ".$wpdb->last_error);
					$result['status'] = "error";
					$result['message'] = "Failed to add search to database";
					echo json_encode($result);
					exit;
				}			}
		}
	//var_dump($result);
	social_sentiment_log("inserting new search succeeded: ");
	$result['status'] = "success";
	$result['search_id'] = $searchId;
	$result['message'] = "search added to database";
	echo json_encode($result);
	exit;
}
//get saved sentiment
add_action('wp_ajax_nopriv_social_sentiment_get_saved_sentiment','social_sentiment_get_saved_sentiment');
add_action('wp_ajax_social_sentiment_get_saved_sentiment','social_sentiment_get_saved_sentiment');
function social_sentiment_get_saved_sentiment(){
	global $wpdb,$social_sentimentConfigTable,$social_sentimentSearchTable,$social_sentimentItemsTable;

	$searches = $wpdb->get_results("SELECT * from `$social_sentimentSearchTable`");
	if(false === $searches){
		social_sentiment_log("Reading saved searches failed: ".$wpdb->last_error);
		$result['status'] = "error";
		$result['message'] = "Failed to read saved searches";
	}
	$c = 0;
	foreach($searches as $search){
		$searchTerm = $search->term;
		$searchType = $search->type;
		if($searchType == 'hash'){
			$searchType = '#';
		}else
		if($searchType == 'at'){
			$searchType = '@';
		}
		$searchId = $search->id;
		$items = $wpdb->get_results("SELECT * from `$social_sentimentItemsTable` WHERE `search_id`=$searchId");
		if(false === $items){
			social_sentiment_log("Reading saved searches failed: ".$wpdb->last_error);
			$result['status'] = "error";
			$result['message'] = "Failed to read saved searches";
		}
		$result['saved_items'][$c]['term'] = $searchTerm;
		$result['saved_items'][$c]['type'] = $searchType;
		$result['saved_items'][$c]['search_id'] = $searchId;
		$result['saved_items'][$c]['items'] = $items;
		$c++;
	}
	$result['status'] = "success";
	$result['message'] = "saved searches retrieved";
	echo json_encode($result);
	exit;
}
//get single saved sentiment
add_action('wp_ajax_nopriv_social_sentiment_get_single_saved_sentiment','social_sentiment_get_single_saved_sentiment');
add_action('wp_ajax_social_sentiment_get_single_saved_sentiment','social_sentiment_get_single_saved_sentiment');
function social_sentiment_get_single_saved_sentiment(){
	global $wpdb,$social_sentimentConfigTable,$social_sentimentSearchTable,$social_sentimentItemsTable;
	$searchIdArray = explode('_',$_POST['id']);
	$searchId = intval($searchIdArray[2]);
	$search = $wpdb->get_results("SELECT * from `$social_sentimentSearchTable` WHERE `id`=$searchId");
	if(false === $search){
		social_sentiment_log("Reading saved searches failed: ".$wpdb->last_error);
		$result['status'] = "error";
		$result['message'] = "Failed to read saved searches";
		echo json_encode($result);
		exit;
	}
	$searchTerm = $search[0]->term;
	$searchType = $search[0]->type;
	if($searchType =='hash'){
		$searchType = '#';
	}else
	if($searchType == 'at'){
		$searchtype = '@';
	}
	$result['search_term'] = $searchType . $searchTerm;
	$items = $wpdb->get_results("SELECT * from `$social_sentimentItemsTable` WHERE `search_id`=$searchId");
	if(false === $items){
		social_sentiment_log("Reading saved searches failed: ".$wpdb->last_error);
		$result['status'] = "error";
		$result['message'] = "Failed to read saved searches";
		echo json_encode($result);
		exit;
	}
	$config = $wpdb->get_results("SELECT * from `$social_sentimentConfigTable`");
	if(false === $config){
		social_sentiment_log("Reading config table for single search failed: ".$wpdb->last_error);
		$result['status'] = "error";
		$result['message'] = "Failed to read config table for single search";
		echo json_encode($result);
		exit;
	}
	if(count($config) > 0){
		$colours[] = $config[0]->positive_colour;
		$colours[] = $config[0]->neutral_colour;
		$colours[] = $config[0]->negative_colour;
		//$coloursString = '"'.$positiveColour.'","'.$neutralColour.'","'.$negativeColour.'"';
	}
	$result['colours'] = $colours;
	$result['items'] = $items;
	$result['status'] = "success";
	$result['message'] = "saved searches retrieved";
	echo json_encode($result);
	exit;
}
//delete sentiment
add_action('wp_ajax_nopriv_social_sentiment_delete_sentiment','social_sentiment_delete_sentiment');
add_action('wp_ajax_social_sentiment_delete_sentiment','social_sentiment_delete_sentiment');
function social_sentiment_delete_sentiment(){
	global $wpdb,$social_sentimentConfigTable,$social_sentimentSearchTable,$social_sentimentItemsTable;
	$idString = $_REQUEST['id'];
	$parts = explode('_',$idString);
	$id = $parts[2];
	$query = $wpdb->prepare("DELETE from `$social_sentimentSearchTable` WHERE `id`=%d",$id);
	$delete = $wpdb->query($query);
	if(false === $delete){
		social_sentiment_log("Deleting search id ".$id." failed: ".$wpdb->last_error);
		$result['status'] = "error";
		$result['message'] = "Failed to delete search";
	}
	$query = $wpdb->prepare("DELETE from `$social_sentimentItemsTable` WHERE `search_id`=%d",$id);
	$delete = $wpdb->query($query);
	if(false === $delete){
		social_sentiment_log("Deleting search id ".$id." failed: ".$wpdb->last_error);
		$result['status'] = "error";
		$result['message'] = "Failed to delete search";
	}
	$result['status'] = "success";
	$result['message'] = "search ".$id." deleted";
	echo json_encode($result);
	exit;
}
//
function social_sentiment_form($number){
	return number_format($number, 2, '.', ' ');
}
function social_sentiment_log($text){
	$logFile = __DIR__."/social_sentiment.log";
	error_log(mm_geo_redirect_timestampToDate(time())." -- ".$text."\n", 3, $logFile);	
}
/* do shortcode */
add_shortcode("social_sentiment","social_sentiment_shortcode");
function social_sentiment_shortcode($atts)
{
	global $wpdb, $social_sentiment_shortcode_loaded;
    
	$social_sentiment_shortcode_loaded = true;
	extract(shortcode_atts(array(
		'id' => '',
		'width' => '',
		'position' => ''
	), $atts));
	
	//$button_name = "{$name}";
	$scId = "{$id}";
	$scWidth = "{$width}";
	$scPosition = "{$position}";
	if($scPosition != 'centre' && $scPosition != 'right' && $scPosition != 'left'){
		$scPosition = 'centre';
	}
	ob_start();
	if($scPosition == 'centre'){
		//centre
		$out = '			
		<div id="ss_piechart_'.$scId.'" class="ss_piechart" style="margin-left:auto;margin-right:auto;width:'.$scWidth.'px;height:'.$scWidth.'px;"></div>
		';
	
	}else
	{
		if($scPosition == 'left'){
			$out = '			
		<div id="ss_piechart_'.$scId.'" class="ss_piechart" style="margin-left:0px;width:'.$scWidth.'px;height:'.$scWidth.'px;"></div>
		';
		}else
		{
			$out = '	<div style="width:100%;position:relative;height:'.$scWidth.'px;">		
		<span id="ss_piechart_'.$scId.'" class="ss_piechart" style="float:right;width:'.$scWidth.'px;height:'.$scWidth.'px;"></span>
		</div>';
		}
		
		
	}

	
	
			echo $out;//to ob

			$result = ob_get_contents(); // get everything in to $result variable
			ob_end_clean();
			return $result;
	
}


function social_sentiment_script() {
	//available in all pages
	global $social_sentiment_shortcode_loaded;
	if(!$social_sentiment_shortcode_loaded){return;}
	?>
	<script>
	google.load("visualization", "1", {packages:["corechart"]});
	google.setOnLoadCallback(process_shortcodes);
	jQuery(document).ready(function(){
		
			
		
		//process_shortcodes();
	});
	function process_shortcodes(){
		console.log('processing shortcodes');
		jQuery('.ss_piechart').each(function(index, element) {
			var id = this.id;
			console.log('id: '+id);
			displaySavedChart(id);
		});
	}
	
	function displaySavedChart(id){

		jQuery.ajax({
			url:"<?php echo admin_url('admin-ajax.php'); ?>",
			type: "POST",
			dataType:"json",
			data:({
				action:"social_sentiment_get_single_saved_sentiment",
				id: id
			}),
			success: function(r){
				
				if(r['status'] == 'success'){	
					if(r['items']){
						//console.log(r['items']);
						var saved_items = r['items'];
						var search_term = r['search_term'];
						var colours = r['colours'];
						N = saved_items.length;
						//console.log('N: '+N);
						if(N > 0){
							createChart(saved_items,search_term,id,colours);
						}else
						{
		
						}
					}else
					{
					}
				}else
				{
					console.log('status: '+r['status']+' ('+r['message']+')');
				}
				
			},
			error: function(jqXHR,error, errorThrown,data) {  
				//console.log(jqXHR.responseText + ' '+error+' '+errorThrown+' '+data);
				console.log(this['url']);
				var text;
				if(jqXHR.responseText){
					text = jqXHR.responseText;
				}else
				{
					if(error){
						text = error;
					}else
					if(errorThrown){
						text = errorThrown;
					}
				}
				console.log(text);
			},
			timeout: 60000
		});
	}
	function createChart(items,search_term,id,colours) {
		//
		//console.log('colours: '+colours);
		s_n = s_p = s_nn = 0;
/*		for(var c=0;c<items.length;c++){
			if(items[c]['score'] > 0){
				s_p++;
			}else
			if(items[c]['score'] < 0){
				s_nn++;
			}else
			{
				s_n++;	
			}
		}*/
		for(var c=0;c<items.length;c++){
			//console.log('pos: '+s_p);
			s_p = s_p + (1.0*items[c]['score_positive']);
			s_nn = s_nn + (1.0*items[c]['score_neutral']);
			s_n = s_n + (1.0*items[c]['score_negative']);
		}
		//
		s_p = Math.round(s_p*100)/100;
		s_nn = Math.round(s_nn*100)/100;
		s_n = Math.round(s_n*100)/100;
		//
		var data = google.visualization.arrayToDataTable([
		  ['Sentiment', 'Percent'],
		  ['positive', s_p],
		  ['Neutral', s_nn],
		  ['Negative', s_n]
		]);

		var options = {
		  title: 'twitter sentiment for '+search_term,
		  titleTextStyle:{fontSize: 12},
		  colors: colours,
		  legend:{position: 'right',alignment: 'start'},
		  chartArea:{left:0,top:'15%',width:'100%',height:'85%'}
		};
		//id will be ss_piechart_nn
		var chart = new google.visualization.PieChart(document.getElementById(id));
		//var chart = new google.visualization.PieChart(document.getElementById(id+'_widget'));
		chart.draw(data, options);
	}
	</script>
   <?php
}
//
// Creating the widget 
class social_sentiment_widget extends WP_Widget {

	function __construct() {
		parent::__construct(
		// Base ID of your widget
		'social_sentiment_widget', 
		
		// Widget name will appear in UI
		__('Social Sentiment', 'social_sentiment_widget_domain'), 
		
		// Widget description
		array( 'description' => __( 'Social sentiment widgets', 'social_sentiment_widget_domain' ), ) 
		);
	}
	
	// Creating widget front-end
	// This is where the action happens
	public function widget( $args, $instance ) {
		global $wpdb,$social_sentimentSearchTable;
		$id = apply_filters( 'widget_title', $instance['title'] );
		// before and after widget arguments are defined by themes
		echo $args['before_widget'];
		if ( ! empty( $id ) ){
			$search = $wpdb->get_results("SELECT * from `$social_sentimentSearchTable` WHERE `id`=$id");
			if(false === $search){
				social_sentiment_log("Reading saved searches failed: ".$wpdb->last_error);
				$result['status'] = "error";
				$result['message'] = "Failed to read saved searches";
				echo json_encode($result);
				exit;
			}
			if(count($search) > 0){
				$searchTerm = $search[0]->term;
				$searchType = $search[0]->type;
				if($searchType =='hash'){
					$searchType = '#';
				}else
				if($searchType == 'at'){
					$searchtype = '@';
				}
				$title = $searchType . $searchTerm;
				echo $args['before_title'] . "Social Sentiment" . $args['after_title'];
			}
		}
		// This is where you run the code and display the output
		//echo __( 'sentiment for ', 'social_sentiment_widget_domain' );
		//echo $title.;
		//echo $title;
		echo '<div id="sswidget_piechart_'.$id.'" class="ss_piechart" style="float:left;width: 80%;height:;"></div>'.$args['after_widget'];
	}
			
	// Widget Backend 
	public function form( $instance ) {
		if ( isset( $instance[ 'title' ] ) ) {
		$title = $instance[ 'title' ];
		}
		else {
		$title = __( 'New title', 'social_sentiment_widget_domain' );
		}
		// Widget admin form
		?>
		<p>
		<label for="<?php echo $this->get_field_id( 'title' ); ?>"><?php _e( 'Title:' ); ?></label> 
		<input class="widefat" id="<?php echo $this->get_field_id( 'title' ); ?>" name="<?php echo $this->get_field_name( 'title' ); ?>" type="text" value="<?php echo esc_attr( $title ); ?>" />
		</p>
		<?php 
	}
		
	// Updating widget replacing old instances with new
	public function update( $new_instance, $old_instance ) {
		$instance = array();
		$instance['title'] = ( ! empty( $new_instance['title'] ) ) ? strip_tags( $new_instance['title'] ) : '';
		return $instance;
	}
} // Class social_sentiment_widget ends here

// Register and load the widget
function social_sentiment_load_widget() {
	register_widget( 'social_sentiment_widget' );
}
add_action( 'widgets_init', 'social_sentiment_load_widget' );
//
/**
 * remove annoying footer thankyou from wordpress that stops people from entering text
 */
function social_sentiment_hide_wordpress_thankyou() {
  echo '<style type="text/css">#wpfooter {display:none;}</style>';
}
 
add_action('admin_head', 'social_sentiment_hide_wordpress_thankyou');
add_action( 'wp_footer', 'social_sentiment_script' ,200);
?>